#include <stdio.h>
#include "pgmlib.h"
#include <math.h>
#include "fft.h"


void make_original_data(int n);
void save_spectrum(int n);


int main() {

	char file[256] = "";
	load_image(0, file);
	make_original_data(0);
	FFT2(1);
	save_spectrum(1);
	save_image(1, file);
	return 0;
}

void make_original_data(int n)
/* 摜No.ñf[^ data[x][y], jdata[x][y] ɑ */
{
	int i, j;

	if (width[n] != height[n]) {
		printf("cƉ̉fقȂĂ̂ŏI܂D\n");
		exit(1);
	}
	else {
		printf("\nǂݍ񂾉摜f[^ɂ܂D\n");
		num_of_data = width[n];
		for (j = 0; j < num_of_data; j++) {
			for (i = 0; i < num_of_data; i++) {
				data[i][j] = (double)image[n][i][j];
				jdata[i][j] = 0.0;  /* 0 */
			}
		}
	}
}


void save_spectrum(int n)
/* UXyNgt@CƂďo͂ */
{
	char file_name[256]; /* t@Cp̕z */
	double power_spectrum[256][256];
	double min_val, max_val;

	int i, j, x, y;         /* [vϐ */
	int num2;


	/* re^2+im^2o */
	num2 = num_of_data / 2;
	for (j = 0; j < num_of_data; j++) {
		if (j < num2) y = j + num2;
		else          y = j - num2;
		for (i = 0; i < num_of_data; i++) {
			if (i < num2) x = i + num2;
			else          x = i - num2;
			power_spectrum[i][j] = pow(data[x][y], 2) + pow(jdata[x][y], 2);
		}
	}

	width[n] = num_of_data;
	height[n] = num_of_data;

	min_val = power_spectrum[0][0];	max_val = power_spectrum[0][0];
	for (j = 0; j < num_of_data; j++) {
		for (i = 0; i < num_of_data; i++) {
			if (min_val > power_spectrum[i][j]) min_val = power_spectrum[i][j];
			if (max_val < power_spectrum[i][j]) max_val = power_spectrum[i][j];
		}
	}

	for (j = 0; j < num_of_data; j++) {
		for (i = 0; i < num_of_data; i++) {
			image[n][i][j] = (power_spectrum[i][j] - min_val) / (max_val - min_val) * 255.0;
		}
	}
}